#include <os.h>
#include "menu.h"
#include "output.h"

#define MENU_BACKGROUND_COLOR ( has_colors?0b1111111111111111:0xC )
#define MENU_SHADOW_COLOR (has_colors?0b0111101111101111:0x5 )
#define MENU_SELECTION_COLOR (has_colors?0b011101111111111:0x0)



//void dispMenuTile(uint8_t* scrbuf, int x, int y, int w, int h, int color, char* option){
//    dispRect(scrbuf, x, y, w, h, 0x0);
//    filledRect(scrbuf, x+1, y+1, w-2, h-2, color);
//    dispString(scrbuf, x+3, y+3, option);
//}

int dispMenu(uint8_t* scrbuf, int x, int y, const char* menu, int selected){//returns number of items in menu
    char* tmpmenu = (char*)malloc(strlen(menu)+1);
    strcpy(tmpmenu,menu);
    int h = CHAR_HEIGHT + 4, w = 0;
    int linelen = 0;
    char* p = tmpmenu;
    for(;*p != '\0';p++){
        if(*p == '\n'){
            h += CHAR_HEIGHT + 4;
            if(linelen > w)
                w = linelen;
            linelen = 0;
        }
        else
            linelen++;
    }
    w = 2 + w*CHAR_WIDTH + CHAR_WIDTH;
    dispRect(scrbuf, x, y, w+2, h+2, 0);
    filledRect(scrbuf, x+1, y+1, w, h, MENU_BACKGROUND_COLOR);
    dispHorizLine(scrbuf, x+1, y+h+2, w+2, MENU_SHADOW_COLOR);
    dispHorizLine(scrbuf, x+2, y+h+3, w+2, MENU_SHADOW_COLOR);
    dispVertLine(scrbuf, x+w+2, y+1, h+2, MENU_SHADOW_COLOR);
    dispVertLine(scrbuf, x+w+3, y+2, h+2, MENU_SHADOW_COLOR);

    char* option = strtok(tmpmenu, "\n");
    y += 3;
    while(option != NULL){
        if(!(--selected)){
            filledRect(scrbuf, x+1, y-2, w, CHAR_HEIGHT+4, MENU_SELECTION_COLOR);
            dispStringColor(scrbuf, x+3, y, option, has_colors?0xFFFF:0xF, MENU_SELECTION_COLOR);
        }
        else
            dispString(scrbuf, x+3, y, option);
        option = strtok(NULL, "\n");
        y += CHAR_HEIGHT + 4;
    }
    free(tmpmenu);
    return h/(CHAR_HEIGHT+4);
}
